#include "NamedCounter.h"

#include <iostream>

using std::cout;
using std::endl;

using std::string;

NamedCounterImpl::NamedCounterImpl(
   const string &name, 
   const CORBA::Long initialValue)
   :  m_name(name),
      m_value(initialValue),
      RefCountedBase("NamedCounterImpl")
{
   cout << "Named counter created: " << this << " \"" << m_name << "\" = " << m_value << endl;
}

NamedCounterImpl::~NamedCounterImpl()
{
   cout << "Named counter destroyed: " << this << " \"" << m_name << "\" = " << m_value << endl;
}

char *NamedCounterImpl::name()
{
   return CORBA::string_dup(m_name.c_str());
}

CORBA::Long NamedCounterImpl::value()
{
   return m_value;
}

void NamedCounterImpl::value(CORBA::Long value)
{
   m_value = value;
}

