#ifndef NAMED_COUNTER_FACTORY__INCLUDED
#define NAMED_COUNTER_FACTORY__INCLUDED

#include "RefCount.h"

#include "NamedCounter.h"

#include "CounterContainer.h"

class NamedCounterFactoryImpl :
   public virtual POA_NamedCounterFactory,
	public virtual PortableServer::RefCountServantBase
{
   public :

//      typedef std::map<std::string, NamedCounterImpl *> CounterContainer;
      typedef TCounterContainer<NamedCounterImpl> CounterContainer;

      NamedCounterFactoryImpl(const size_t numCounters);
      ~NamedCounterFactoryImpl();

      // implement the interface

      virtual NamedCounter_ptr GetNamedCounter(
         const char* name);

      virtual void AddNamedCounter(
         const char* name, 
         CORBA::Long initialValue);
  
      virtual void RemoveNamedCounter(
         const char* name);

      virtual counterSeq *GetAll();

      virtual EnumNamedCounter_ptr GetEnumerator();

      virtual counterDataSeq *GetAllReadOnly();
  
      virtual EnumNamedCounterData_ptr GetEnumeratorReadOnly();

   private :

      CounterContainer m_counters;

      // do not implement - restrict copying
      NamedCounterFactoryImpl(const NamedCounterFactoryImpl &rhs);
      NamedCounterFactoryImpl &operator =(const NamedCounterFactoryImpl &rhs);
};

#endif NAMED_COUNTER_FACTORY__INCLUDED